Package icyllis.arc3d.compiler.tree

# Record Class Type.Field

java.lang.Object
java.lang.Record
icyllis.arc3d.compiler.tree.Type.Field

Record Components:
  `position` - see `Position`

Enclosing class:
  `Type`

public static record Type.Field(int position, Modifiers modifiers, Type type, String name) extends Record
Represents a single field in a struct/block type. Not associated with Variable.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Field(int position, Modifiers modifiers, Type type, String name)`
  Creates an instance of a `Field` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `Modifiers`
  `modifiers()`
  Returns the value of the `modifiers` record component.
  `String`
  `name()`
  Returns the value of the `name` record component.
  `int`
  `position()`
  Returns the value of the `position` record component.
  `String`
  `toString()`
  Returns a string representation of this record class.
  `Type`
  `type()`
  Returns the value of the `type` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Field

    public Field(int position, Modifiers modifiers, Type type, String name)
    Creates an instance of a `Field` record class.
    Parameters:
      `position` - the value for the `position` record component
      `modifiers` - the value for the `modifiers` record component
      `type` - the value for the `type` record component
      `name` - the value for the `name` record component

- ## Method Details

  - ### toString

    @Nonnull public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### position

    public int position()
    Returns the value of the `position` record component.
    Returns:
      the value of the `position` record component

  - ### modifiers

    public Modifiers modifiers()
    Returns the value of the `modifiers` record component.
    Returns:
      the value of the `modifiers` record component

  - ### type

    public Type type()
    Returns the value of the `type` record component.
    Returns:
      the value of the `type` record component

  - ### name

    public String name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component